﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using word = Microsoft.Office.Interop.Word;

namespace ProductPR
{
    /// <summary>
    /// Логика взаимодействия для ProductListPage.xaml
    /// </summary>
    public partial class ProductListPage : Page
    {
        List<Product> Prod = DatebaseClass.DB.Product.ToList();
        public ProductListPage()
        {
            InitializeComponent();
            LVPrMat.ItemsSource = Prod;
            List<ProductType> GB = DatebaseClass.DB.ProductType.ToList();
            CBSearch.Items.Add("Все");
            for (int i = 0; i < GB.Count(); i++)
            {
                CBSearch.Items.Add(GB[i].Title);
            }
            CBSearch.SelectedIndex = 0;
        }

        private void TextBlock_Loaded(object sender, RoutedEventArgs e)
        {
            TextBlock tb = (TextBlock)sender;
            int index = Convert.ToInt32(tb.Uid);
            List<ProductMaterial> TC = DatebaseClass.DB.ProductMaterial.Where(x => x.ProductID == index).ToList();
            string title = "";

            foreach (ProductMaterial item in TC)
            {
                title += item.Material.Title + ", ";
            }
            if (title != "")
            {
                tb.Text = "Материалы: " + title.Substring(0, title.Length - 2);

            }
            else
            {
                tb.Text = title;
            }
        }
        List<Product> ProdSeacrh;
        private void Seacrch()
        {
            int index = CBSearch.SelectedIndex;
            if (index != 0)
            {
                ProdSeacrh = Prod.Where(x => x.ProductTypeID == index).ToList();
            }
            else
            {
                ProdSeacrh = Prod;
            }
            if (!string.IsNullOrWhiteSpace(TBSearch.Text))
            {
                ProdSeacrh = ProdSeacrh.Where(x => x.Title.ToLower().Contains(TBSearch.Text) || x.Title.Contains(TBSearch.Text)).ToList();
            }
            LVPrMat.ItemsSource = ProdSeacrh;
        }

        private void TextBlock_Loaded_1(object sender, RoutedEventArgs e)
        {
            TextBlock tb = (TextBlock)sender;
            int index = Convert.ToInt32(tb.Uid);
            List<ProductMaterial> TC = DatebaseClass.DB.ProductMaterial.Where(x => x.ProductID == index).ToList();
            decimal cost = 0;

            foreach (ProductMaterial item in TC)
            {
                cost += item.Material.Cost;
            }

            tb.Text = "Стоимость: " + cost;
        }

        private void CbSort_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Seacrch();
        }

        private void TbSearch_TextChanged(object sender, TextChangedEventArgs e)
        {
            Seacrch();
        }

        private void BtnSortUp_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            
        }

        private void selectybv_Selected(object sender, RoutedEventArgs e)
        {
            ProdSeacrh.Sort((x, y) => x.Title.CompareTo(y.Title));
            LVPrMat.Items.Refresh();
        }

        private void sekectyb_Selected(object sender, RoutedEventArgs e)
        {
            ProdSeacrh.Sort((x, y) => x.Title.CompareTo(y.Title));
            ProdSeacrh.Reverse();
            LVPrMat.Items.Refresh();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            editwindow winProduct = new editwindow();
            winProduct.ShowDialog();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            var Allproduct = DatebaseClass.DB.Material.ToList();
            var Allmaterial = DatebaseClass.DB.Product.ToList();
            var application = new word.Application();
            word.Document document = application.Documents.Add();
            foreach (var product in Allproduct)
            {
                word.Paragraph productparagraph = document.Paragraphs.Add();
                word.Range productrange = productparagraph.Range;
                productrange.Text = product.Title;
                productrange.set_Style("Title");
                productrange.InsertParagraphAfter();

                word.Paragraph tablleParagraph = document.Paragraphs.Add();
                word.Range tableRange = tablleParagraph.Range;
                word.Table paymentsTable = document.Tables.Add(tableRange, Allmaterial.Count() + 1, 3);

            }
        }

        private void BtnChange_Click(object sender, RoutedEventArgs e)
        {
            editwindow editWindow = new editwindow();
            editWindow.ShowDialog();
        }
    }

        
}
