﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;



namespace ProductPR
{
    /// <summary>
    /// Логика взаимодействия для editwindow.xaml
    /// </summary>
    public partial class editwindow : Window
    {
        string path;
        bool flag = false;
        List<Material> MT = DatebaseClass.DB.Material.ToList();
        public editwindow()
        {
            InitializeComponent();
            CbTypePr.ItemsSource = DatebaseClass.DB.MaterialType.ToList();
            CbTypePr.SelectedValuePath = "ID";
            CbTypePr.DisplayMemberPath = "Title";

            CbMaterial.ItemsSource = DatebaseClass.DB.Material.ToList();
            CbMaterial.SelectedValuePath = "ID";
            CbMaterial.DisplayMemberPath = "Title";
            flag = true;

            LbMaterial.ItemsSource = DatebaseClass.DB.Material.ToList();
            LbMaterial.SelectedValuePath = "ID";
            LbMaterial.DisplayMemberPath = "Title";
        }
        Product Edit = new Product();
        public editwindow(Product ED)
        {
            InitializeComponent();
            Edit = ED;

            CbTypePr.ItemsSource = DatebaseClass.DB.MaterialType.ToList();
            CbTypePr.SelectedValuePath = "ID";
            CbTypePr.DisplayMemberPath = "Title";

            TbTitle.Text = Edit.Title;
            TbArt.Text = Edit.ArticleNumber.ToString();
            TbCountHum.Text = Edit.ProductionPersonCount.ToString();
            TbNumb.Text = Edit.ProductionWorkshopNumber.ToString();
            TbMinCost.Text = Edit.MinCostForAgent.ToString();

            if (Edit.Image != null)
            {
                BitmapImage BI = new BitmapImage(new Uri(Edit.Image, UriKind.RelativeOrAbsolute));
                ProductImage.Source = BI;
            }

            CbMaterial.ItemsSource = DatebaseClass.DB.Material.ToList();
            CbMaterial.SelectedValuePath = "ID";
            CbMaterial.DisplayMemberPath = "Title";
            LbMaterial.SelectedValuePath = "ID";
            LbMaterial.DisplayMemberPath = "Title";
        }

        private void ButtMaterialAdd_Click(object sender, RoutedEventArgs e)
        {
            List<Material> MT = DatebaseClass.DB.Material.ToList();
            LbMaterial.Items.Add(MT.FirstOrDefault(x => x.ID == CbMaterial.SelectedIndex + 1));
        }

        private void ButtMaterialRemove_Click(object sender, RoutedEventArgs e)
        {
            LbMaterial.Items.Remove(LbMaterial.SelectedItem);
        }
        private void ButtEditImage_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                OpenFileDialog OFD = new OpenFileDialog();
                OFD.ShowDialog();
                path = OFD.FileName;
                int n = path.IndexOf("product");
                path = path.Substring(n);
                BitmapImage img = new BitmapImage(new Uri(path, UriKind.RelativeOrAbsolute));
                ProductImage.Source = img;
            }
            catch
            {
                MessageBox.Show("Нет картинки", "Редактирование", MessageBoxButton.OK, MessageBoxImage.Warning);
            }
        }
        private void ButtUpdate_Click(object sender, RoutedEventArgs e)
        {

            Edit.Title = TbTitle.Text;
            Edit.ProductTypeID = CbTypePr.SelectedIndex + 1;
            Edit.ArticleNumber = TbArt.Text;
            Edit.ProductionPersonCount = Convert.ToInt32(TbCountHum.Text);
            Edit.ProductionWorkshopNumber = Convert.ToInt32(TbNumb.Text);
            Edit.MinCostForAgent = Convert.ToInt32(TbMinCost.Text);
            Edit.Description = TbDescription.Text;
            Edit.Image = path;
            if (flag == true)
            {
                DatebaseClass.DB.Product.Add(Edit);
            }
            DatebaseClass.DB.SaveChanges();
            MessageBox.Show(Edit.ID.ToString());

            List<Material> MTID = MT.Where(x => x.ID == Edit.ID).ToList();
            if (MTID.Count != 0)
            {
                foreach (Material mt in MTID)
                {
                    DatebaseClass.DB.Material.Remove(mt);
                }
            }
            foreach (Material t in LbMaterial.Items)
            {
                Material mt = new Material();
                mt.ID = Edit.ID;
                mt.ID = t.ID;
                DatebaseClass.DB.Material.Add(mt);
                MessageBox.Show(mt.ID.ToString());
            }
            DatebaseClass.DB.SaveChanges();
            MessageBox.Show("Данные записаны", "Редактирование", MessageBoxButton.OK, MessageBoxImage.Asterisk);
        }
    }
}
